package cn.iocoder.yudao.module.system.controller.admin.biz;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.framework.tenant.core.context.TenantContextHolder;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlyassessanxiety.ElderlyAssessAnxietyPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlyassessanxiety.ElderlyAssessAnxietyRespVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlyassessanxiety.ElderlyAssessAnxietySaveReqVO;
import cn.iocoder.yudao.module.system.service.biz.ElderlyAssessAnxietyService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Tag(name = "管理后台 - 焦虑自评量表")
@RestController
@RequestMapping("/elderly-assess-anxiety")
@Validated
public class ElderlyAssessAnxietyController {

    @Resource
    private ElderlyAssessAnxietyService elderlyAssessAnxietyService;

    @PostMapping("/create")
    @Operation(summary = "创建焦虑自评量表")
    public CommonResult<Long> create(@Valid @RequestBody ElderlyAssessAnxietySaveReqVO createReqVO) {
        if (createReqVO.getTenantId() == null) {
            createReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(elderlyAssessAnxietyService.create(createReqVO));
    }

    @PutMapping("/update")
    @Operation(summary = "更新焦虑自评量表")
    @TenantIgnore
    public CommonResult<Boolean> update(@Valid @RequestBody ElderlyAssessAnxietySaveReqVO updateReqVO) {
        if (updateReqVO.getTenantId() == null) {
            updateReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        elderlyAssessAnxietyService.update(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除焦虑自评量表")
    @Parameter(name = "id", description = "编号", required = true)
    @TenantIgnore
    public CommonResult<Boolean> delete(@RequestParam("id") Long id) {
        elderlyAssessAnxietyService.delete(id);
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得焦虑自评量表详情")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<ElderlyAssessAnxietyRespVO> get(@RequestParam("id") Long id) {
        return success(elderlyAssessAnxietyService.get(id));
    }

    @GetMapping("/page")
    @Operation(summary = "获得焦虑自评量表分页")
    @TenantIgnore
    public CommonResult<PageResult<ElderlyAssessAnxietyRespVO>> page(@Valid ElderlyAssessAnxietyPageReqVO pageReqVO) {
        if (pageReqVO.getTenantIds() == null) {
            pageReqVO.setTenantIds(new Long[]{TenantContextHolder.getTenantId()});
        }
        return success(elderlyAssessAnxietyService.getPage(pageReqVO));
    }
}
